<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable
                      class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search"
                       class="filter-item">搜索
            </el-button>
            <el-button @click="this.$router.go(-1)" type="primary" icon="el-icon-arrow-left"
                       class="filter-item">返回
            </el-button>
            <!--            <el-button @click="download" type="primary" icon="el-icon-download"
                                   :loading="downloading" class="filter-item">导出EXCEL
                        </el-button>-->
        </div>
        <el-table :data="tableData" row-key="id" ref="table"
                  header-row-class-name="table-header-row"
                  header-cell-class-name="table-header-cell"
                  row-class-name="table-row" cell-class-name="table-cell"
                  :height="tableHeight">
            <el-table-column v-if="multipleMode" align="center" type="selection"
                             width="50">
            </el-table-column>
            <el-table-column prop="id" label="ID" width="100">
            </el-table-column>
            <el-table-column prop="userNickname" label="用户昵称"
            >
            </el-table-column>
            <!--<el-table-column prop="avatar" label="头像"
            >
                <template slot-scope="{row}">
                    <el-image style="width: 30px; height: 30px"
                              :src="row.avatar" fit="cover"
                              :preview-src-list="[row.avatar]"></el-image>
                </template>
            </el-table-column>-->
            <el-table-column prop="content" label="内容"
            >
                <template slot-scope="{row}">
                    <el-tag v-for="item in row.content" :key="item" type="info">{{item}}</el-tag>
                </template>
            </el-table-column>
            <!--    <el-table-column prop="img" label="图片"
                >
                    <template slot-scope="{row}">
                        <el-image style="width: 30px; height: 30px"
                                  :src="picList(row.img)[0]" fit="cover"
                                  :preview-src-list="picList(row.img)?picList(row.img):[]"></el-image>
                    </template>
                </el-table-column>-->
            <el-table-column prop="riderAppraise" label="骑手评价内容"
            >
            </el-table-column>
            <el-table-column prop="riderLike" label="骑手评分"
            >
                <template slot-scope="{row}">
                    <el-rate
                            v-model="row.riderLike"
                            disabled
                            :max='3'
                            style="padding-bottom: 8px"
                    >
                    </el-rate>
                </template>
            </el-table-column>
            <el-table-column prop="merShowName" label="商家名称"
            >
            </el-table-column>
            <el-table-column prop="date" label="评价日期"
                             :formatter="datetimeFormatter"
            >
            </el-table-column>
            <el-table-column
                    label="操作"
                    align="center"
                    fixed="right"
                    min-width="150">
                <template slot-scope="{row}">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>详情</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination background @size-change="onSizeChange"
                           @current-change="onCurrentChange" :current-page="page"
                           :page-sizes="[10, 20, 30, 40, 50]" :page-size="pageSize"
                           layout="total, sizes, prev, pager, next, jumper"
                           :total="totalElements">
            </el-pagination>
        </div>

    </div>
</template>
<script>
    import {mapState} from "vuex";
    import pageableTable from "@/mixins/pageableTable";

    export default {
        name: 'AppraisalList',
        mixins: [pageableTable],
        created() {
            this.getData();
        },
        data() {
            return {
                multipleMode: false,
                search: "",
                url: "/appraisal/ridPage",
                downloading: false,
            }
        },
        computed: {
            selection() {
                return this.$refs.table.selection.map(i => i.id);
            }
        },
        methods: {
            picList(row) {
                if (row) {
                    return row.split(",");
                } else {
                    return "";
                }
            },
            beforeGetData() {
                let data = {
                    query: {
                        rid: this.$route.query.rid,
                    }
                };
                if (this.search) {
                    data.search = this.search
                }
                return data;
            },

            /*          if (this.search) {
                          return {search: this.search};
                      }*/

            toggleMultipleMode(multipleMode) {
                this.multipleMode = multipleMode;
                if (!multipleMode) {
                    this.$refs.table.clearSelection();
                }
            },
            addRow() {
                this.$router.push({
                    path: "/appraisalEdit",
                    query: {
                        ...this.$route.query
                    }
                });
            },
            editRow(row) {
                this.$router.push({
                    path: "/appraisalEdit",
                    query: {
                        id: row.id
                    }
                });
            },
            download() {
                this.downloading = true;
                this.$axios
                    .get("/appraisal/excel", {
                        responseType: "blob",
                        params: {size: 10000}
                    })
                    .then(res => {
                        console.log(res);
                        this.downloading = false;
                        const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                        const link = document.createElement("a");
                        link.href = downloadUrl;
                        link.setAttribute(
                            "download",
                            res.headers["content-disposition"].split("filename=")[1]
                        );
                        document.body.appendChild(link);
                        link.click();
                        link.remove();
                    })
                    .catch(e => {
                        console.log(e);
                        this.downloading = false;
                        this.$message.error(e.error);
                    });
            },
            operation1() {
                this.$notify({
                    title: '提示',
                    message: this.selection
                });
            },
            operation2() {
                this.$message('操作2');
            },
            deleteRow(row) {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/appraisal/del/${row.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                }).catch(action => {
                    if (action === 'cancel') {
                        this.$message.info('删除取消');
                    } else {
                        this.$message.error('删除失败');
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
